<template>
    <div>
        <v-container>
            <v-row class="mb-6">
                <v-col sm="12" md="4"></v-col>
                <v-col sm="12" md="4">
                    <v-sheet class="pa-2 ma-2">
                        <h1>Modelo predictivo para precio de celulares</h1>
                        <form @submit.prevent="submitForm($event)">
                            <v-row class="mb-0 mt-0" >
                                <v-col sm="12" offset-sm="12" md="6">
                                    <div>
                                        <label for="sistemaOperativo">Sistema operativo:</label>
                                        <v-select
                                            @update:modelValue="updateOptionsByOS(true)"
                                            v-model="telefono.sistemaOperativo"
                                            id="sistemaOperativo"
                                            name="sistemaOperativo"
                                            :items="['Android', 'iOS']"
                                            :rules="[v => !!v || 'Item is required']"
                                            label="Sistema Operativo"
                                            density="compact"
                                            required
                                        ></v-select>
                                    </div>
                                </v-col>
                                <v-col sm="12" offset-sm="12" md="6">
                                    <div>
                                        <label for="marca">Marca:</label>
                                        <v-select
                                            id="marca"
                                            v-model="dinFrmmarca"
                                            :items="telefono.sistemaOperativo === 'iOS' ? ['Apple'] : ['Samsung', 'Google', 'OnePlus', 'Xiaomi']"
                                            :rules="[v => !!v || 'Item is required']"
                                            label="Marca"
                                            density="compact"
                                            name="marca"
                                            required
                                        ></v-select>
                                    </div>
                                </v-col>
                            </v-row>
                            <v-row class="mb-0 mt-0">
                                <v-col sm="12" offset-sm="12" md="8">
                                    <div>
                                        <label for="procesador">Procesador:</label>
                                        <v-select
                                            id="procesador"
                                            v-model="dinFrmprocesador"
                                            :items="telefono.sistemaOperativo === 'iOS' ? ['A14 Bionic', 'A13 Bionic'] : ['Snapdragon', 'Exynos', 'Kirin']"
                                            :rules="[v => !!v || 'Item is required']"
                                            label="Procesador"
                                            density="compact"
                                            name="procesador"
                                            required
                                        ></v-select>
                                    </div>
                                </v-col>
                                <v-col sm="12" offset-sm="12" md="4">
                                    <div>
                                        <label for="ram">RAM:</label>
                                        <v-select
                                            id="ram"
                                            :items="[{text: '4 GB', id: '4GB'}, {text: '6 GB', id: '6GB'}, {text: '8 GB', id: '8GB'}, {text: '12 GB', id: '12GB'}]"
                                            :rules="[v => !!v || 'Item is required']"
                                            item-title="text"
                                            item-value="id"
                                            label="Ram"
                                            density="compact"
                                            name="ram"
                                            required
                                        ></v-select>
                                    </div>
                                </v-col>
                            </v-row>
                            <div>
                                <label for="almacenamiento">Almacenamiento:</label>
                                <v-select
                                    id="almacenamiento"
                                    :items="[{text: '64 GB', id: '64GB'}, {text: '128 GB', id: '128GB'}, {text: '256 GB', id: '256GB'}, {text: '512 GB', id: '512GB'}]"
                                    :rules="[v => !!v || 'Item is required']"
                                    item-title="text"
                                    item-value="id"
                                    label="Almacenamiento"
                                    density="compact"
                                    name="almacenamiento"
                                    required
                                ></v-select>
                            </div>
                            <div>
                                <label for="resolucion">Resolución de pantalla:</label>
                                <v-select
                                    id="resolucion"
                                    :items="[{text: '480 x 800 px', id: '480x800'}, {text: '720 x 1280 px', id: '720x1280'}, {text: '1080 x 1920 px', id: '1080x1920'}, {text: '1440 x 2560 px', id: '1440x2560'}]"
                                    :rules="[v => !!v || 'Item is required']"
                                    item-title="text"
                                    item-value="id"
                                    label="Resolución"
                                    density="compact"
                                    name="resolucion"
                                    required
                                ></v-select>
                            </div>
                            <div>
                                <label for="bateria">Batería:</label>
                                <v-select
                                    id="bateria"
                                    :items="[{text: '3000 mAh', id: '3000mAh'}, {text: '3110 mAh', id: '3110mAh'}, {text: '3700 mAh', id: '3700mAh'}, {text: '4500 mAh', id: '4500mAh'}]"
                                    :rules="[v => !!v || 'Item is required']"
                                    item-title="text"
                                    item-value="id"
                                    label="Batería"
                                    density="compact"
                                    name="bateria"
                                    required
                                ></v-select>
                            </div>
                            <div>
                                <label for="seguridad">Seguridad:</label>
                                <v-select
                                    id="seguridad"
                                    :items="['Huella', 'FaceID', 'Reconocimiento facial', 'Touch ID']"
                                    :rules="[v => !!v || 'Item is required']"
                                    label="Seguridad"
                                    density="compact"
                                    name="seguridad"
                                    required
                                ></v-select>
                            </div>
                            <v-btn type="submit" block class="mt-2" color="success">Calcular</v-btn>
                
                        </form>
                        <br><br>
                        <div v-if="result !== null">
                            <p>
                                Predicción: El precio aproximado de un dispositivo movíl con las características que ha especificado es de <b>S./ {{ result }}</b> Nuevos Soles
                            </p>
                        </div>
                    </v-sheet>
                </v-col>
                <v-col sm="12" md="4"></v-col>
            </v-row>
        </v-container>

    </div>
</template>
<script setup lang="ts">
    import { ref } from "vue";
    import axios from 'axios';

    useHead({
        title: 'Modelo predictivo'
    })
    
    let dinFrmmarca = ref('');
    let dinFrmprocesador = ref('');
    
    let result = ref<Number | null>(null);
    let telefono = ref({sistemaOperativo: 'Android'});

    function updateOptionsByOS(v:boolean) : boolean {
        dinFrmmarca.value = '';
        dinFrmprocesador.value = '';
        return true;
    }
    function submitForm(event: Event) : void {
        try {
            (async () => {
                let response = await axios.post('api/AzureMachineLearning', new FormData(event.target as HTMLFormElement), {
                    headers: { 'Content-Type': 'application/json' }
                });
                result.value = parseFloat(parseFloat(response.data.Results.output1[0]["Scored Labels"]).toFixed(2));
                // result.value = response.data.Results.output1["Scored Labels"];
            })();
        } catch (error) {
            result.value = null;
        }
    }


</script>